import { Signal } from "@mezzy/signals";
import IMetricsGroup from "./iMetricsGroup";
export default interface IMetrics {
    internalSet: IMetricsGroup;
    readonly schema: string[];
    readonly array: number[];
    readonly isEmpty: boolean;
    readonly copy: IMetrics;
    readonly set: IMetricsGroup;
    isSignalChanged: boolean;
    magnitude: number;
    magnitudeSquared: number;
    abs: this;
    readonly changed: Signal<this>;
    to(values: number[]): IMetrics;
    toObject(): any;
    toJson(): string;
    equals(values: number[]): boolean;
    add(values: number[]): this;
    subtract(values: number[]): this;
    multiply(values: number[]): this;
    multiplyNumber(value: number): this;
    divide(values: number[]): this;
    dot(values: number[]): number;
    distanceSquared(values: number[]): number;
    distance(values: number[]): number;
    min(values: number[]): this;
    max(values: number[]): this;
    clamp(min: number[], max: number[]): this;
}
